#code for preparing a text file with BASH code for batch download of NARCLIM data for the HUNTER WQ modeling of 
#future climate scenarios 

#NARCLIM Variables
#evspsblmean   	water_evaporation flux (actual ET) long_name: Surface evaporation standard_name: water_evaporation_flux units: kg m-2 s-1
#tasmean      mean near surface temperature
#pracc 		precipitation daily precipitation sum (sum of convective prcacc and stratiform prncacc precip) 

Clim_Var <- 'sstmean'
Datatype <- 'T_NNRP'  #T_GCMS for GCM forcing, T_NNRP for reanalysis (only 1950-2009)
Biasboolean <- 'False' #use bias corrected data? True or False python boolean

Directory <- 'C:/Users/z5025317/OneDrive - UNSW/Hunter_CC_Modeling/07_Modelling/01_Input/BCGeneration/catchments/'   
Filename <- 'Catchment_Prev_Hunter_Model_Centroids_VH_WGS84_attribute_Table.csv'

Directory <- 'C:/Users/z5025317/OneDrive - UNSW/WRL_Postdoc_Manual_Backup/WRL_Postdoc/Projects/Paper#1/Data/NARCLIM_Site_CSVs/CASESTUDY_GAB/'
Filename <- 'CASESTUDY2_GAB_NARCLIM_Point_Sites_V4.csv'

#Load CSV with location names and lat lon coordinates
Location.df <- data.frame(read.csv(paste(Directory, Filename, sep=""), header=T))

for(type in c('min','max')){
  #create empty vector for storing the command line text and open file
  Vector.for.command.line.txt <- c()
  Vector.for.command.line.txt <- c(Vector.for.command.line.txt, "module load python")
  text1 <- c(paste("Datatype='",Datatype,"'", sep=""),
  paste("Bias_corrected='",Biasboolean,"'", sep=""), paste("ClimVarName='",Clim_Var,"'", sep=""))
  Vector.for.command.line.txt <- c(Vector.for.command.line.txt, text1)
  
  for (i in 1:(length(Location.df[,1]))){
  #for (i in c(1,5,10)){ if only subset of catchments is needed like for Met file. 
    #name<-as.character(Location.df$Name[i])
    #name<-gsub('([[:punct:]])|\\s+','_',name)
    if(type == 'min'){
      #latlongs <- as.character(Location.df[,9])
      name <- as.character(Location.df[,1][i])
      latitude <- as.character(Location.df[,2][i])
      longitude <- as.character(Location.df[,3][i])
      }else if(type == 'max'){
      name <- as.character(Location.df[,6][i])
      latitude<-as.character(Location.df[,7][i])
      longitude<-as.character(Location.df[,8][i])
      }
    # print(latlongs[i])
    # names <- as.character(Location.df[,17])
    # if(i<10){
    #   name<-paste('Plant_0', as.character(i), sep="")
    # }else{
    #   name<-paste('Plant_', as.character(i), sep="")
    # }
    #print(name)
    #print(names[i])
    # latmin <- substr(latlongs[i], 5, 10)
    # lonmin <- substr(latlongs[i], 18, 23)
    # latmax <- substr(latlongs[i], 32, 37)
    # lonmax <- substr(latlongs[i], 45, 50)
    # latitude=latmax
    # longitude=lonmax
text <- c(paste("latitude=",latitude,"", sep=""), paste("longitude=",longitude,"", sep=""),
paste("name='",name,"'", sep=""),
"python /srv/ccrc/data02/z5025317/Code_execution/\\
P1_NARCliM_NC_to_CSV_CCRC_SS.py \\
--lat $latitude --lon $longitude --varName $ClimVarName --domain 'd01' --timestep \\
'DAY' --LocationName $name --Datatype $Datatype --BiasBool $Bias_corrected")
Vector.for.command.line.txt <- c(Vector.for.command.line.txt, text)
    
    if(i==10|i==20|i==30|i==40|i==45){
      Vector.for.command.line.txt <- c(Vector.for.command.line.txt, " ")
      text.file.name <- paste('C:/Users/z5025317/OneDrive - UNSW/WRL_Postdoc_Manual_Backup/WRL_Postdoc/Projects/Paper#1/Data/NARCLIM_Site_CSVs/CASESTUDY_GAB/DataDownloadCCRC/',Clim_Var, "_", Datatype, "_", Biasboolean,as.character(i), type, ".txt", sep="")
      #open and fill text file
      fileConn <- file(text.file.name)
      writeLines(Vector.for.command.line.txt, fileConn)
      close(fileConn)
      Vector.for.command.line.txt <- c()
      Vector.for.command.line.txt <- c(Vector.for.command.line.txt, "module load python")
      text1 <- c(paste("Datatype='",Datatype,"'", sep=""),
                 paste("Bias_corrected='",Biasboolean,"'", sep=""), paste("ClimVarName='",Clim_Var,"'", sep=""))
      Vector.for.command.line.txt <- c(Vector.for.command.line.txt, text1)
      }
    }
}
